                 /*ͻ
                  C Easy sample3.c: Browse Selection 
                 */

#include "\ceasy\ceasy1.h"       // required C Easy header files
#include "\ceasy\ceasy2.h"

#define line     5               // top line of screen edit window
#define column   5               // left column of screen edit window
#define width    66

char *browsearea;                // pointer to browse area in memory

main()
{
 char        selection [width];
 static char programs [] [66] =  // table of program names
  {
   " 1 sample1  Browse Window       browse()                          ",
   " 2 sample2  Browse File Edit    read_text() browse() write_text() ",
   " 3 sample3  THIS PROGRAM        browse_select()                   ",
   " 4 sample4  Browse Checklist    browse_check()                    ",
   " 5 sample5  Browse Check Edit   browse_check_edit()               ",
   " 6 sample6  Browse View Only    read_text() browse_view()         ",
   " 7 sample7  Pull Down Menu      select_down()                     ",
   " 8 sample8  Bar Menu            select_across()                   ",
   " 9 sample9  Bar and Pulldown    select_across select_down()       ",
   " A sampleA  Conventional Menu   process_menu()                    ",
   " B sampleB  Simple Query Form   enter_form()                      ",
   " C sampleC  Combined Data Entry new_form() enter_form()           ",
   " D sampleD  Point and CLick     mouse() graphics overlay()        ",
   " E Exit                                                           ",
   " F sampleF  Music, sort of      tone()                            ",
   " G sampleG  Bouncing Graphics   get_image() display_guage ...     "
  };

 start_program ();                 // required

 while (1)
  {
   initialize ();                  // screen colors & memory initialization

   WINDOW_OFFSET = LAST_OFFSET/width;  // starting line within window

   cursor( line-3, column );       // position for title
   set_color ( BKGND_BLUE );       // turn on title colors
   set_color ( FGND_YELLOW );
   see (
   "   Program  Demonstates        C Easy Functions Involved         " );
   browse_select (                 // browse and select a program name
          programs,                // points to browse area in memory
          sizeof(programs),        // size of browse are in memory
          width,                   // width of screen window
          sizeof(programs)/width,  // height of screen window
          line,                    // top line of screen window
          column );                // left column of screen window

   // returns: LAST_OFFSET   = displacement in window of selected line
   //          LAST_LINE_PTR = pointer to beginning of selected line

   if ( LAST_CHAR < '1' || toupper(LAST_CHAR) > 'G' )
    {
     move ( LAST_LINE_PTR+3,       // move 8 characters to selection array
            selection,
            8 );

     compare ( selection, "Exit", 4 );  // compare selection to 'Exit'
     if ( EQUAL ) break;
     call_program ( make_string (selection, 8 ), NULL );
    }
   else                                 // else select bar was moved
    {
     set_color ( BKGND_WINDOW );        // restore current bar line
     set_color ( FGND_WINDOW );
     see_ ( LAST_LINE_PTR, width );

     set_color ( BKGND_RED );           // set select bar colors
     set_color ( FGND_YELLOW );

     switch ( toupper (LAST_CHAR ) )    // switch based on last key pressed
      {
       case ( '1' ) :

         cursor( line, column );            // position (bar) to selected item
         see_( &programs[0], width );       // display the item
         call_program ( "sample1" , NULL ); // spawn sample1.exe, no arguments
         break;

       case ( '2' ) :

         cursor( line+1, column );
         see_( &programs[1], width );
         call_program ( "sample2" , NULL );
         break;

       case ( '3' ) :

         cursor( line+2, column );
         see_( &programs[2], width );
         call_program ( "sample3" , NULL );
         break;

       case ( '4' ) :

         cursor( line+3, column );
         see_( &programs[3], width );
         call_program ( "sample4" , NULL );
         break;

       case ( '5' ) :

         cursor( line+4, column );
         see_( &programs[4], width );
         call_program ( "sample5" , NULL );
         break;

       case ( '6' ) :

         cursor( line+5, column );
         see_( &programs[5], width );
         call_program( "sample6" , NULL );
         break;

       case ( '7' ) :

         cursor( line+6, column );
         see_( &programs[6], width );
         call_program( "sample7" , NULL );
         break;

       case ( '8' ) :

         cursor( line+7, column );
         see_( &programs[7], width );
         call_program ( "sample8" , NULL );
         break;

       case ( '9' ) :

         cursor( line+8, column );
         see_( &programs[8], width );
         call_program ( "sample9" , NULL) ;
         break;

       case ( 'A' ) :

         cursor( line+9, column );
         see_( &programs[9], width );
         call_program ( "sampleA" , NULL) ;
         break;

       case ( 'B' ) :

         cursor( line+10, column );
         see_( &programs[10], width );
         call_program ( "sampleB" , NULL) ;
         break;

       case ( 'C' ) :

         cursor( line+11, column );
         see_( &programs[11], width );
         call_program ( "sampleC" , NULL) ;
         break;

       case ( 'D' ) :

         cursor( line+12, column );
         see_( &programs[12], width );
         call_program ( "sampleD" , NULL) ;
         break;

       case ( 'E' ) :

         cursor( line+13, column );
         see_( &programs[13], width );
         stop_program (0);

       case ( 'F' ) :

         cursor( line+14, column );
         see_( &programs[14], width );
         call_program ( "sampleF" , NULL) ;
         break;

       case ( 'G' ) :

         cursor( line+15, column );
         see_( &programs[15], width );
         call_program ( "sampleG" , NULL) ;
         break;

       default : break;
      }
    }
  }
 stop_program (0);               // required
 return (0);                     // to inhibit warning
}

int initialize()
{
 clear_screen ( BKGND_GRAY, FGND_YELLOW );
 BKGND_WINDOW = BKGND_BLUE;  ;   // background color for window
 FGND_WINDOW  = FGND_YELLOW  ;   // foreground color for window
 BKGND_BAR    = BKGND_RED    ;
 FGND_BAR     = FGND_YELLOW  ;
 FRAME_TYPE   = SINGLE_LINE  ;   // window frame double line (not single)
 BKGND_FRAME  = BKGND_BLUE   ;   // backgound color for window frame
 FGND_FRAME   = FGND_RED     ;   // foregound color for window frame
 SHADOW_TYPE  = RIGHT_SHADOW ;   // frame shadow on right (not left)
 BKGND_SHADOW = BKGND_BLACK  ;   // frame shadow color
 BKGND_TIME   = BKGND_GRAY   ;   // background color for time
 enable_time( 'C', SL, 66 );     // enable mouse and display time
 return (0);
}
